;
	Processor	16F84
;
       include <p16f84.inc>
;
_CP_OFF		EQU	H'3FFF'
_WDT_OFF	EQU	H'3FFB'
_XT_OSC		EQU	H'3FFD'
_ResetVector	EQU	H'0000'
_IntVector	EQU	H'0004'
;
impulse	EQU	0ch
;
	org	_ResetVector
	goto	Start
;
	org	_IntVector
	bcf	INTCON,T0IF	;Timer overflow rcksetzen
	call	Ausgabe
	bcf	STATUS,RP0	;Bank0
	clrf	IMPULSE
	movlw	0x16
	movwf	TMR0		;Timer Zeit setzen
	retfie

Start	bcf	STATUS,RP1	;Aufwrtskompatibilitt
	bcf	STATUS,RP0	;Bank0 whlen
	clrf	INTCON		;
	clrf	PORTA		;Ports rcksetzen
	clrf	PORTB
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	clrf	impulse		;Impulszhler resetten
	bcf	STATUS,RP0	;Bank0
	movlw	0xA0
	movwf	INTCON		;interrupt enables setzen
	movlw	0x16
	movwf	TMR0		;Timer Zeit setzen
	bsf	STATUS,RP0	;Bank1
	movlw	0x87
	movwf	OPTION_REG		;Prescaler/Timer setzen, aktivieren

schl4l	bcf	STATUS,RP0	;Bank0
	btfss	PORTA,4		;auf H an RA4 warten, dann H-Schleife 
	goto	schl4l
	incf	impulse,1	;impulse hochzhlen
schl4h	bcf	STATUS,RP0	;Bank0
	btfsc	PORTA,4		;auf L an RA4 warten, dann L-Schleife
	goto	schl4h
	goto	schl4l
Ausgabe
	movlw	0x00		;Abfrage des Impulszhlers
	subwf	impulse,0	;bei imp=1 1LED leucht aufrufen usw.
	btfsc	STATUS,Z
	call	LED_0
	movlw	0x01
	subwf	impulse,0
	btfsc	STATUS,Z
	call	LED_1
	movlw	0x02
	subwf	impulse,0
	btfsc	STATUS,Z
	call	LED_2
	movlw	0x03
	subwf	impulse,0
	btfsc	STATUS,Z
	call	LED_3
	movlw	0x04
	subwf	impulse,0
	btfsc	STATUS,Z
	call	LED_4
	movlw	0x05
	subwf	impulse,0
	btfsc	STATUS,Z
	call	LED_5
	movlw	0x06
	subwf	impulse,0
	btfsc	STATUS,Z
	call	LED_6
	movlw	0x07
	subwf	impulse,0
	btfsc	STATUS,Z
	call	LED_7
	movlw	0x08
	subwf	impulse,0
	btfsc	STATUS,Z
	call	LED_8
	movlw	0x09
	subwf	impulse,0
	btfsc	STATUS,Z
	call	LED_9
	movlw	0x0A
	subwf	impulse,0
	btfsc	STATUS,Z
	call	LED_10
	movlw	0x0B
	subwf	impulse,0
	btfsc	STATUS,Z
	call	LED_11
	movlw	0x0C
	subwf	impulse,0
	btfsc	STATUS,C	;gilt fr imp>11
	call	LED_12
	retfie

LED_12
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	bcf	STATUS,RP0
	movlw	0xFF
	movwf	PORTB
	movlw	0x0F
	movwf	PORTA
	retfie
LED_11
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	bcf	STATUS,RP0
	movlw	0xFE
	movwf	PORTB
	movlw	0x0F
	movwf	PORTA
	retfie
LED_10
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	bcf	STATUS,RP0
	movlw	0xFC
	movwf	PORTB
	movlw	0x0F
	movwf	PORTA
	retfie
LED_9
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	bcf	STATUS,RP0
	movlw	0x07F8
	movwf	PORTB
	movlw	0x0F
	movwf	PORTA
	retfie
LED_8
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	bcf	STATUS,RP0
	movlw	0xF0
	movwf	PORTB
	movlw	0x0F
	movwf	PORTA
	retfie
LED_7
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	bcf	STATUS,RP0
	movlw	0xE0
	movwf	PORTB
	movlw	0x0F
	movwf	PORTA
	retfie
LED_6
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	bcf	STATUS,RP0
	movlw	0xC0
	movwf	PORTB
	movlw	0x0F
	movwf	PORTA
	retfie
LED_5
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	bcf	STATUS,RP0
	movlw	0x80
	movwf	PORTB
	movlw	0x0F
	movwf	PORTA
	retfie
LED_4
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	bcf	STATUS,RP0
	movlw	0x00
	movwf	PORTB
	movlw	0x0F
	movwf	PORTA
	retfie
LED_3
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	bcf	STATUS,RP0
	movlw	0x00
	movwf	PORTB
	movlw	0x0E
	movwf	PORTA
	retfie
LED_2
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	bcf	STATUS,RP0
	movlw	0x00
	movwf	PORTB
	movlw	0x0C
	movwf	PORTA
	retfie
LED_1
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	bcf	STATUS,RP0
	movlw	0x00
	movwf	PORTB
	movlw	0x08
	movwf	PORTA
	retfie
LED_0
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x10
	movwf	TRISA		;Ra4 input Rest output
	bcf	STATUS,RP0
	movlw	0x00
	movwf	PORTB
	movlw	0x00
	movwf	PORTA
	retfie

	END
